com.smartgwt.client.widgets.layout

## Class NavigationBar

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.HLayout
            - - com.smartgwt.client.widgets.layout.NavigationBar

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasDownClickHandlers, HasMembersChangedHandlers, HasNavigationClickHandlers, HasUpClickHandlers

      public class NavigationBar
      extends HLayout
      implements HasDownClickHandlers, HasNavigationClickHandlers, HasUpClickHandlers

  Navigation control implemented as a horizontal layout showing back and forward controls and a title.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NavigationBar()`
    `NavigationBar(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.event.shared.HandlerRegistration` | `addDownClickHandler(DownClickHandler handler)` Add a downClick handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addNavigationClickHandler(NavigationClickHandler handler)` Add a navigationClick handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addUpClickHandler(UpClickHandler handler)` Add a upClick handler.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `boolean` | `getAlwaysShowLeftButtonTitle()` If set, the left button title will never be omitted in an attempt to fit the full title.
    `Canvas` | `getCustomNavControl()` An arbitrary component that will be placed where the `miniNavControl` AutoChild would normally be placed (see `miniNavAlign`).
    `NavigationButton` | `getLeftButton()` The button displayed to the left of the title in this NavigationBar.
    `java.lang.String` | `getLeftButtonIcon()` `Icon` for the `leftButton`.
    `java.lang.String` | `getLeftButtonTitle()` `Title` for the `leftButton`.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `int` | `getMaxCenterOffset()` Maximum amount in pixels that the title will be placed off center in an effort to avoid clipping it - see `title`.
    `Alignment` | `getMiniNavAlign()` Placement of `MiniNavControl`, if present: "right" alignment places the miniNav on the far right "center" alignment places the miniNav in the center, or to the right of the title if the title is present "left" alignment will place the miniNav on the left, or to the right of the `leftButton` if its present.
    `MiniNavControl` | `getMiniNavControl()` AutoChild of type `MiniNavControl`.
    `static NavigationBar` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `NavigationButton` | `getRightButton()` The button displayed to the right of the title in this NavigationBar.
    `java.lang.String` | `getRightButtonIcon()` `Icon` for the `rightButton`.
    `java.lang.String` | `getRightButtonTitle()` `Title` for the `rightButton`.
    `java.lang.String` | `getShortLeftButtonTitle()` Short title to display for the left button title if there is not enough room to show the title for the navigation bar.
    `boolean` | `getShowMiniNavControl()` If set to `false`, then the `miniNavControl` is not shown.
    `java.lang.String` | `getTitle()` The title to display in the center of this navigation bar.
    `Label` | `getTitleLabel()` The AutoChild label used to display the `title` in this NavigationBar.
    `void` | `setAlwaysShowLeftButtonTitle(boolean alwaysShowLeftButtonTitle)` If set, the left button title will never be omitted in an attempt to fit the full title.
    `void` | `setCustomNavControl(Canvas customNavControl)` An arbitrary component that will be placed where the `miniNavControl` AutoChild would normally be placed (see `miniNavAlign`).
    `static void` | `setDefaultProperties(NavigationBar navigationBarProperties)` Class level method to set the default properties of this class.
    `void` | `setLeftButtonIcon(java.lang.String leftButtonIcon)` `Icon` for the `leftButton`.
    `void` | `setLeftButtonTitle(java.lang.String leftButtonTitle)` `Title` for the `leftButton`.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.layout.NavigationBarLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMaxCenterOffset(int maxCenterOffset)` Maximum amount in pixels that the title will be placed off center in an effort to avoid clipping it - see `title`.
    `void` | `setMiniNavAlign(Alignment miniNavAlign)` Placement of `MiniNavControl`, if present: "right" alignment places the miniNav on the far right "center" alignment places the miniNav in the center, or to the right of the title if the title is present "left" alignment will place the miniNav on the left, or to the right of the `leftButton` if its present.
    `void` | `setRightButtonIcon(java.lang.String rightButtonIcon)` `Icon` for the `rightButton`.
    `void` | `setRightButtonTitle(java.lang.String rightButtonTitle)` `Title` for the `rightButton`.
    `void` | `setShortLeftButtonTitle(java.lang.String shortLeftButtonTitle)` Short title to display for the left button title if there is not enough room to show the title for the navigation bar.
    `void` | `setShowLeftButton(boolean visible)` Show or hide the `leftButton`.
    `void` | `setShowMiniNavControl(boolean showMiniNavControl)` If set to `false`, then the `miniNavControl` is not shown.
    `void` | `setShowRightButton(boolean visible)` Show or hide the `rightButton`.
    `void` | `setTitle(java.lang.String title)` The title to display in the center of this navigation bar.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.HLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSkinImgDir, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSkinImgDir, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### NavigationBar

          public NavigationBar()

    - #### NavigationBar

          public NavigationBar(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static NavigationBar getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `HLayout`

    - #### setAlwaysShowLeftButtonTitle

          public void setAlwaysShowLeftButtonTitle(boolean alwaysShowLeftButtonTitle)

      If set, the left button title will never be omitted in an attempt to fit the full title. See the documentation of `title` for details.
      If this method is called after the component has been drawn/initialized: Setter for `alwaysShowLeftButtonTitle`.
      Parameters:
        `alwaysShowLeftButtonTitle` - new value for `alwaysShowLeftButtonTitle`.. Default value is false

    - #### getAlwaysShowLeftButtonTitle

          public boolean getAlwaysShowLeftButtonTitle()

      If set, the left button title will never be omitted in an attempt to fit the full title. See the documentation of `title` for details.
      Returns:
        boolean

    - #### setCustomNavControl

          public void setCustomNavControl(Canvas customNavControl)

      An arbitrary component that will be placed where the `miniNavControl` AutoChild would normally be placed (see `miniNavAlign`).
      If this method is called after the component has been drawn/initialized: Setter to update the `customNavControl` at runtime.
      Parameters:
        `customNavControl` - Default value is null

    - #### getCustomNavControl

          public Canvas getCustomNavControl()

      An arbitrary component that will be placed where the `miniNavControl` AutoChild would normally be placed (see `miniNavAlign`).
      Returns:
        Canvas

    - #### getLeftButton

          public NavigationButton getLeftButton()
                                         throws java.lang.IllegalStateException

      The button displayed to the left of the title in this NavigationBar. By default this will be a `NavigationButton` with `direction` set to `NavigationDirection.BACK`.

      The following `passthroughs` apply:

      - `leftButtonTitle` for `title`
      - `leftButtonIcon` for `icon`

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        NavigationButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setLeftButtonIcon

          public void setLeftButtonIcon(java.lang.String leftButtonIcon)

      `Icon` for the `leftButton`.
      If this method is called after the component has been drawn/initialized: Setter for `leftButtonIcon`.
      Parameters:
        `leftButtonIcon` - new icon for left button. See `SCImgURL` . Default value is "[SKIN]back_arrow.png"

    - #### getLeftButtonIcon

          public java.lang.String getLeftButtonIcon()

      `Icon` for the `leftButton`.
      Returns:
        See `SCImgURL`

    - #### setLeftButtonTitle

          public void setLeftButtonTitle(java.lang.String leftButtonTitle)

      `Title` for the `leftButton`.
      If this method is called after the component has been drawn/initialized: Setter for `leftButtonTitle`.
      Parameters:
        `leftButtonTitle` - new title HTML for the left button. See `HTMLString` . Default value is "&nbsp;"

    - #### getLeftButtonTitle

          public java.lang.String getLeftButtonTitle()

      `Title` for the `leftButton`.
      Returns:
        See `HTMLString`

    - #### setMaxCenterOffset

          public void setMaxCenterOffset(int maxCenterOffset)
                                  throws java.lang.IllegalStateException

      Maximum amount in pixels that the title will be placed off center in an effort to avoid clipping it - see `title`.
      Parameters:
        `maxCenterOffset` - Default value is 40
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMaxCenterOffset

          public int getMaxCenterOffset()

      Maximum amount in pixels that the title will be placed off center in an effort to avoid clipping it - see `title`.
      Returns:
        int

    - #### setMiniNavAlign

          public void setMiniNavAlign(Alignment miniNavAlign)
                               throws java.lang.IllegalStateException

      Placement of `MiniNavControl`, if present:
      - "right" alignment places the miniNav on the far right
      - "center" alignment places the miniNav in the center, or to the right of the title if the title is present
      - "left" alignment will place the miniNav on the left, or to the right of the `leftButton` if its present.
      Parameters:
        `miniNavAlign` - Default value is "right"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMiniNavAlign

          public Alignment getMiniNavAlign()

      Placement of `MiniNavControl`, if present:
      - "right" alignment places the miniNav on the far right
      - "center" alignment places the miniNav in the center, or to the right of the title if the title is present
      - "left" alignment will place the miniNav on the left, or to the right of the `leftButton` if its present.
      Returns:
        Alignment

    - #### getMiniNavControl

          public MiniNavControl getMiniNavControl()
                                           throws java.lang.IllegalStateException

      AutoChild of type `MiniNavControl`. Not shown by default (see `showMiniNavControl`). Also, if a `customNavControl` is provided, then the `customNavControl` is used instead of an automatically created `miniNavControl`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        MiniNavControl
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getRightButton

          public NavigationButton getRightButton()
                                          throws java.lang.IllegalStateException

      The button displayed to the right of the title in this NavigationBar. By default this will be a `NavigationButton` with `direction` set to `"forward"`.

      The following `passthroughs` apply:

      - `rightButtonTitle` for `title`
      - `rightButtonIcon` for `icon`

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        NavigationButton
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setRightButtonIcon

          public void setRightButtonIcon(java.lang.String rightButtonIcon)

      `Icon` for the `rightButton`.
      If this method is called after the component has been drawn/initialized: Setter for `rightButtonIcon`.
      Parameters:
        `rightButtonIcon` - new icon for the right button. See `SCImgURL` . Default value is null

    - #### getRightButtonIcon

          public java.lang.String getRightButtonIcon()

      `Icon` for the `rightButton`.
      Returns:
        See `SCImgURL`

    - #### setRightButtonTitle

          public void setRightButtonTitle(java.lang.String rightButtonTitle)

      `Title` for the `rightButton`.
      If this method is called after the component has been drawn/initialized: Setter for `rightButtonTitle`.
      Parameters:
        `rightButtonTitle` - new title HTML for the right button. See `HTMLString` . Default value is "&nbsp;"

    - #### getRightButtonTitle

          public java.lang.String getRightButtonTitle()

      `Title` for the `rightButton`.
      Returns:
        See `HTMLString`

    - #### setShortLeftButtonTitle

          public void setShortLeftButtonTitle(java.lang.String shortLeftButtonTitle)

      Short title to display for the left button title if there is not enough room to show the title for the navigation bar. Setting to null or an empty string ("") will avoid a shortened title ever being used. See `title` for a full description.
      If this method is called after the component has been drawn/initialized: Setter for `shortLeftButtonTitle`.
      Parameters:
        `shortLeftButtonTitle` - new short title HTML. See `HTMLString` . Default value is "Back"

    - #### getShortLeftButtonTitle

          public java.lang.String getShortLeftButtonTitle()

      Short title to display for the left button title if there is not enough room to show the title for the navigation bar. Setting to null or an empty string ("") will avoid a shortened title ever being used. See `title` for a full description.
      Returns:
        See `HTMLString`

    - #### setShowMiniNavControl

          public void setShowMiniNavControl(boolean showMiniNavControl)
                                     throws java.lang.IllegalStateException

      If set to `false`, then the `miniNavControl` is not shown.
      Parameters:
        `showMiniNavControl` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowMiniNavControl

          public boolean getShowMiniNavControl()

      If set to `false`, then the `miniNavControl` is not shown.
      Returns:
        boolean

    - #### setTitle

          public void setTitle(java.lang.String title)

      The title to display in the center of this navigation bar.

      If there is not enough room for the title with the current titles of the `left` and `right` buttons, space will be used as follows:

      - if the title can be fully visible without clipping if it is placed slightly off-center, it will be placed off-center, up to a maximum of `maxCenterOffset` pixels
      - if that's not enough space, if a `shortLeftButtonTitle` is provided, it will be used in lieu of the normal left button title
      - if that's still not enough space, the title of the left button will be hidden, leaving only the icon. This will be skipped if either `alwaysShowLeftButtonTitle` has been set or the button has no icon, which would leave the space blank.
      - if that's still not enough space, the title text will be clipped, showing an ellipsis (where browser support allows this)
      If this method is called after the component has been drawn/initialized: Updates the `title` for this `NavigationBar`.
      Overrides:
        `setTitle` in class `Canvas`
      Parameters:
        `title` - new title HTML. See `HTMLString` . Default value is null

    - #### getTitle

          public java.lang.String getTitle()

      The title to display in the center of this navigation bar.

      If there is not enough room for the title with the current titles of the `left` and `right` buttons, space will be used as follows:

      - if the title can be fully visible without clipping if it is placed slightly off-center, it will be placed off-center, up to a maximum of `maxCenterOffset` pixels
      - if that's not enough space, if a `shortLeftButtonTitle` is provided, it will be used in lieu of the normal left button title
      - if that's still not enough space, the title of the left button will be hidden, leaving only the icon. This will be skipped if either `alwaysShowLeftButtonTitle` has been set or the button has no icon, which would leave the space blank.
      - if that's still not enough space, the title text will be clipped, showing an ellipsis (where browser support allows this)
      Overrides:
        `getTitle` in class `Canvas`
      Returns:
        See `HTMLString`

    - #### getTitleLabel

          public Label getTitleLabel()
                              throws java.lang.IllegalStateException

      The AutoChild label used to display the `title` in this NavigationBar.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Label
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### addDownClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addDownClickHandler(DownClickHandler handler)

      Add a downClick handler.

      Notification method fired when the down button on the `miniNavControl` is clicked.

      Specified by:
        `addDownClickHandler` in interface `HasDownClickHandlers`
      Parameters:
        `handler` - the downClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addNavigationClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addNavigationClickHandler(NavigationClickHandler handler)

      Add a navigationClick handler.

      Notification method fired when the user clicks the `leftButton` or `rightButton`

      Specified by:
        `addNavigationClickHandler` in interface `HasNavigationClickHandlers`
      Parameters:
        `handler` - the navigationClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### setShowLeftButton

          public void setShowLeftButton(boolean visible)

      Show or hide the `leftButton`.
      Parameters:
        `visible` - if true, the button will be shown, otherwise hidden.

    - #### setShowRightButton

          public void setShowRightButton(boolean visible)

      Show or hide the `rightButton`.
      Parameters:
        `visible` - if true, the button will be shown, otherwise hidden.

    - #### addUpClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addUpClickHandler(UpClickHandler handler)

      Add a upClick handler.

      Notification method fired when the up button on the `miniNavControl` is clicked.

      Specified by:
        `addUpClickHandler` in interface `HasUpClickHandlers`
      Parameters:
        `handler` - the upClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### setDefaultProperties

          public static void setDefaultProperties(NavigationBar navigationBarProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `navigationBarProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.layout.NavigationBarLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `HLayout`